%LQG

clc
clear all
close all

%parametros del tanque:
A=0;
Bu=0.02;
Bd=-0.1;
B=[Bd Bu];
C=1;
D=[0 0];

%% parametros de diseo del control LQR
Q=1;
R=0.1;
[K,Plqr,E]=lqr(A,Bu,Q,R);
%
kr=-inv(C*inv(A-Bu*K)*Bu);


%% parametros para diseo del FK

%planta aumentada
Aa=[0 -0.1; 0 0];
Ba=[0.02; 0];
Ca=[1 0];
W=[0.01 0; 0 0.0001];
V=0.001;
G=eye(2);
%
[Kd,Pfk]=lqr(Aa',Ca',G*W*G',V);
L=Kd';

% observador optimo
Ao=Aa-L*Ca;
Bo=[Ba L];
Co=eye(2);
Do=zeros(2,2);